import sys, os
import wx

class WallpaperChanger(object):
	# Windows
	SPI_SETDESKWALLPAPER = 20
	SPIF_UPDATEINIFILE = 0x01;
	SPIF_SENDWININICHANGE = 0x02;
	
	# Linux
	GNOME_BACKGROUND_SCHEMA = '/desktop/gnome/background/picture_filename'
	
	# Mac OS X
	
	supportedPlatforms = ['win32', 'linux2', 'darwin']
	
	def __init__(self):
		self.checkPlatform()
		
	def checkPlatform(self):
		if sys.platform not in self.supportedPlatforms:
			raise OSError, 'Unsupported platform: %s' % sys.platform
		
		if not sys.platform == 'linux2':
			self.platform = sys.platform
		else:
			try:
				import gconf
			except ImportError, message:
				raise OSError, 'gconf module is needed for linux platform.'
			else:
				self.platform = 'gnome'

	def apply(self, imagePath):
		platformIndependentApply = getattr(self, "apply%s" % self.platform.capitalize())
		platformIndependentApply(imagePath)

	def applyWin32(self, imagePath):
		import ctypes
		return bool(ctypes.windll.user32.SystemParametersInfoA(SPI_SETDESKWALLPAPER, 0, filePath, SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE))
	   
	def applyGnome(self, imagePath):
		import gconf
		client = gconf.client_get_default()
		return client.set_string(self.GNOME_BACKGROUND_SCHEMA, imagePath)
	
	def applyDarwin(self, imagePath):
		# TODO: fill me up :)
		return False

changer = WallpaperChanger()
changeWallpaper = changer.apply