import wx

class TaskBarFrame(wx.Frame):
    TBMENU_SHOW = wx.NewId()
    TBMENU_CLOSE = wx.NewId()
    def __init__(self, *args, **kws):
        wx.Frame.__init__(self, *args, **kws)
        self.tbicon = wx.TaskBarIcon() 

        wx.EVT_CLOSE(self, self.OnWxFrameClose)
        wx.EVT_TASKBAR_LEFT_DCLICK(self.tbicon, self.OnTaskBarActivate) 
        wx.EVT_TASKBAR_LEFT_UP(self.tbicon, self.OnTaskBarActivate) 
        wx.EVT_TASKBAR_RIGHT_UP(self.tbicon, self.OnTaskBarMenu) 
        wx.EVT_MENU(self.tbicon, self.TBMENU_SHOW, self.OnTaskBarActivate) 
        wx.EVT_MENU(self.tbicon, self.TBMENU_CLOSE, self.OnTaskBarClose) 

	# TaskBarIcon handlers
    def OnTaskBarActivate(self, evt): 
        #if self.IsIconized(): 
        #    self.Iconize(false) 
        #if not self.IsShown(): 
        self.Show(True) 
        wx.GetApp().ProcessIdle() 
        #self.Raise() 

    def OnTaskBarMenu(self, evt): 
        menu = wx.Menu() 
        menu.Append(self.TBMENU_SHOW, "&Show") 
        menu.Append(self.TBMENU_CLOSE,   "&Close") 
        self.tbicon.PopupMenu(menu) 
        menu.Destroy() 
        wx.GetApp().ProcessIdle() 

    def OnTaskBarClose(self, evt): 
        self.Destroy() 
        wx.GetApp().ProcessIdle()# ???? 
