# -*- coding: cp949 -*-
import os
import sys

import wx
import Configuration

import WeatherReader
import Changer


[wxID_FRAME1BUTTON1, wxID_FRAME1BUTTON2, wxID_FRAME1BUTTON3, 
 wxID_FRAME1BUTTON4, wxID_FRAME1LISTBOX1,
 wxID_FRAME1CHOICE1, wxID_FRAME1CHOICE2, wxID_FRAME1CHOICE3, 
 wxID_FRAME1PANEL1, wxID_FRAME1STATICBITMAP1, wxID_FRAME1STATICBOX1, 
 wxID_FRAME1STATICBOX2, wxID_FRAME1STATICTEXT1, wxID_FRAME1STATICTEXT2, 
 wxID_FRAME1STATICTEXT3
] = [wx.NewId() for _init_ctrls in range(15)]

class WeatherPanel(wx.Panel):
    def __init__(self, *args, **kws): 
        self.conf = Configuration.Configuration()

        wx.Panel.__init__(self, *args, **kws)#style=wx.TAB_TRAVERSAL, name='', parent=prnt, pos=wx.DefaultPosition, id=wxID_PANEL1, size=wx.Size(200, 100))
        
        self.staticBoxLocation = wx.StaticBox(id=wxID_FRAME1STATICBOX1, 
                label='Location', name='staticBoxLocation', parent=self, 
                pos=wx.Point(16, 16), size=wx.Size(352, 88), style=0)

        self.staticTextCountry = wx.StaticText(id=wxID_FRAME1STATICTEXT1, 
            label='Country', name='staticTextCountry', parent=self, 
            pos=wx.Point(40, 40), size=wx.Size(50, 16), style=0)

        self.staticTextCity = wx.StaticText(id=wxID_FRAME1STATICTEXT2, 
            label='City', name='staticTextCity', parent=self, 
            pos=wx.Point(64, 72), size=wx.Size(27, 16), style=0)

        countryNameList = Configuration.getCountryNameList()
        self.choiceCountry = wx.Choice(choices=countryNameList, id=wxID_FRAME1CHOICE1, 
            name='choiceCountry', parent=self, pos=wx.Point(105, 40), 
            size=wx.Size(240, 22), style=0)
                        # FIXME extract method?
        indexOfSelectedCountry = countryNameList.index(self.conf.country)
        self.choiceCountry.SetSelection(indexOfSelectedCountry)
        self.Bind(wx.EVT_CHOICE, self.OnChoiceCountry, self.choiceCountry)

        cityList, defaultCity = Configuration.getCityList(self.conf.country)
        self.choiceCity = wx.Choice(choices=cityList, id=wxID_FRAME1CHOICE2, 
                name='choiceCity', parent=self, pos=wx.Point(105, 72), 
                size=wx.Size(240, 22), style=0)

        self.setDefaultCity(cityList, self.conf.city)
        self.Bind(wx.EVT_CHOICE, self.OnChoiceCity, self.choiceCity)

        self.staticBox2 = wx.StaticBox(id=wxID_FRAME1STATICBOX2, 
            label='Wallpapers', name='staticBox2', parent=self, 
            pos=wx.Point(16, 128), size=wx.Size(352, 176), style=0)

        self.wallpaperBitmap = wx.StaticBitmap(bitmap=wx.NullBitmap, 
                id=wxID_FRAME1STATICBITMAP1, name='wallpaperBitmap', 
                parent=self, pos=wx.Point(40, 162), size=wx.Size(128, 96), 
                style=0)
        imagePath = os.path.join('images', 'NoImage.bmp')
        self.changeWallpaperBitmap(imagePath)

        self.listBoxWeather = wx.ListBox(parent=self, id=wxID_FRAME1LISTBOX1, pos=wx.Point(205, 162), size=wx.Size(140, 96), 
                choices=Configuration.WEATHERLIST, style=0, validator=wx.DefaultValidator)
        self.Bind(wx.EVT_LISTBOX, self.OnListBoxChoice, self.listBoxWeather)

        self.buttonChange = wx.Button(id=wxID_FRAME1BUTTON1, label='Change', 
                name='buttonChange', parent=self, pos=wx.Point(270, 272), 
                size=wx.Size(75, 24), style=0)
        self.Bind(wx.EVT_BUTTON, self.OnChange, self.buttonChange)

        self.cautionText = wx.StaticText(self, -1, "Service Unavailable", (130, 110), (120, -1), wx.ALIGN_CENTER)
        self.cautionText.SetBackgroundColour('Red')
        

        #FIXME
        self.lastWeather = WeatherReader.WeatherData()
        self.lastWeather.setAttr('condition', 'XXX')

    def setDefaultCity(self, cityList, defaultCityName):
        if not defaultCityName in cityList:
            self.choiceCity.SetSelection(0)
        else:
            indexOfSelectedCity = cityList.index(defaultCityName)
            self.choiceCity.SetSelection(indexOfSelectedCity)

    def OnChoiceCountry(self, evt):
        cityList, defaultCity = Configuration.getCityList(evt.GetString())
        self.choiceCity.SetItems(cityList)
        self.setDefaultCity(cityList, defaultCity)

        self.conf.setCountry(evt.GetString())
        self.conf.setCity(defaultCity)
        self.conf.save()

    def OnChoiceCity(self, evt):
        self.changeWallpaper()
        self.conf.setCity(evt.GetString())
        self.conf.save()

    def OnChange(self, evt):
        wildcard = "Image files (*.jpg;*.gif;*.bmp)|*.jpg;*.gif;*.jpeg;*.bmp;*.JPG;*.GIF;*.JPEG;*.BMP" 

        dlg = wx.FileDialog(self, message="Choose a file", 
                defaultDir=os.getcwd(), 
                defaultFile="", 
                wildcard=wildcard,
                style=wx.OPEN | wx.CHANGE_DIR)
        if dlg.ShowModal() == wx.ID_OK:
            self.imagePath = dlg.GetPaths()[0]
            self.changeWallpaperBitmap(self.imagePath)
            selectedWeather = self.listBoxWeather.GetString(self.listBoxWeather.GetSelection())
            newPath = self.conf.copyWallpaper(selectedWeather, self.imagePath)
            #FIXME ?????? ?????? 
            img = wx.Image(newPath, wx.BITMAP_TYPE_ANY)
            img.SaveFile(newPath, wx.BITMAP_TYPE_BMP)

            self.lastWeather = WeatherReader.WeatherData()
            self.lastWeather.setAttr('condition', 'XXX')
            self.changeWallpaper()

        os.chdir(self.conf.path) # XXX
        dlg.Destroy()
       
    def changeWallpaperBitmap(self, path):
        img = wx.Image(path, wx.BITMAP_TYPE_ANY)
        img.Rescale(128, 96) # FIXME  size..
        self.wallpaperBitmap.SetBitmap(img.ConvertToBitmap())


    def OnListBoxChoice(self, evt):
        fname = evt.GetString()
        imagePath = os.path.join(self.conf.wallpaperFolder, fname) 
        if not os.path.exists(imagePath):
            imagePath = os.path.join(self.conf.path, 'images', 'NoImage.bmp')
        self.changeWallpaperBitmap(imagePath)

    def OnButtonCancel(self, evt): 
        prnt = self.Parent
        while prnt.Parent:
            prnt = prnt.Parent
        prnt.Destroy()

    #TODO - Method Implementation
    def changeWallpaper(self): # FIXME
        selectedCity = self.choiceCity.GetString(self.choiceCity.GetSelection())
        curWeather = WeatherReader.getWeather(selectedCity)
        if not curWeather:
            self.cautionText.Show(True)
            return
        self.cautionText.Show(False)
        if self.lastWeather.condition != curWeather.condition:
            path = os.path.join(self.conf.wallpaperFolder, curWeather.condition)
            self.lastWeather = curWeather
            if os.path.exists(path):
                Changer.changeWallpaper(path)


